<?
require ('func.inc');
?>
<HTML>
<HEAD>
<TITLE>IPChains Firewall Web Administration Script.</TITLE>
<?php

#
# $Id: index.php3,v 2.0 2000/01/19 del Exp $
#
# PHP based firewall script generator by Del <del@babel.com.au>
# Design and Functionality updates by Ed McLain <edm@tuial.com>

#
# Define some constants.
#

$CONF="/var/lib/phpchains";
$netobjects = read_objects();
$rules = read_rulesets();
#############################################################################
#
# Read in all definitions.
#
#############################################################################

$interfaces = file("$CONF/interfaces");

$protocolr = file("/etc/protocols");
$rules = read_rulesets();
$netobjects = read_objects();

while ( list( $key, $val ) = each($protocolr) ) {
  #
  # Skip blank lines and comments
  #
  if ( strlen($val) < 5 ) continue;
  if ( substr($val, 0, 1) == "#" ) continue;
  $exploded = preg_split ("/[\s\/]+/", $val);
  $protocols[$exploded[0]] = intval($exploded[1]);
  $port = intval($exploded[1]);
}
asort($protocols);

$servicer = file("/etc/services");
while ( list( $key, $val ) = each($servicer) ) {
  #
  # Skip blank lines and comments
  #
  if ( strlen($val) < 5 ) continue;
  if ( substr($val, 0, 1) == "#" ) continue;
  $exploded = preg_split ("/[\s\/]+/", $val);
  $service = $exploded[0];
  $port = intval($exploded[1]);
  $proto = $exploded[2];
  $services["$service/$proto"] = $port;
}
asort($services);

function writefile(){
$netobjects = read_objects();
$rules = read_rulesets();
#############################################################################
# Write Script to file
#############################################################################

print "Re-Writing File.........<BR>";
$objfile = fopen ("fwscript","w+");
fwrite ($objfile, "
#############################################################################\n
# Initialise Firewall Configuration\n
#############################################################################\n
\n
IPCHAINS=\"/sbin/ipchains\"\n
\n
#\n
# Network object definitions.\n
#\n");
reset($netobjects);
while ( list( $key, $val ) = each( $netobjects ) ) {
  $exploded = explode (" ", $val);
  fwrite ($objfile, "$key='$exploded[0]/$exploded[1]'\n");
}

fwrite ($objfile, "
#\n
# Turn on forwarding and dynamic addressing.\n
#\n
echo 1 > /proc/sys/net/ipv4/ip_forward\n
echo 1 > /proc/sys/net/ipv4/ip_dynaddr\n
\n
#\n
# Turn on anti-spoofing.\n
#\n
for file in /proc/sys/net/ipv4/conf/*/rp_filter; do\n
  echo 1 > \$file\n
done\n
\n
#\n
# Set IP Masquerade timeouts to sensible defaults.\n
#\n
\$IPCHAINS -M -S 7200 10 60\n
\n
#\n
# Flush all rulesets.\n
#\n
\$IPCHAINS -F input\n
\$IPCHAINS -F output\n
\$IPCHAINS -F forward\n
\n
#\n
# Allow loopback interface\n
#\n
\$IPCHAINS -A input -i lo -s \$ALL -d \$ALL -j ACCEPT\n
\$IPCHAINS -A output -i lo -s \$ALL -d \$ALL -j ACCEPT\n
\n
#\n
# Deny all other forwarding.\n
#\n
\$IPCHAINS -P forward DENY\n
\n
#############################################################################\n
# Input Rules\n
#############################################################################\n
#\n
\n
");

if (is_array($rules)) {
  reset($rules);
  while ( list($key,$rule) = each($rules) ) {
    list ($type, $source, $dest, $proto, $port, $action, $log) = preg_split ("/[\s]+/", $rule);
    if ($type == "INPUT") {
    $log=chop($log);
    fwrite ($objfile, "\$IPCHAINS -A input");
    if ($proto != "ALL") fwrite ($objfile, " -p $proto");
    fwrite ($objfile, " -s $$source -d $$dest");
    if ($port != "ALL") fwrite ($objfile, " $port");
    fwrite ($objfile, " -j $action");
    if ($log == "YES") fwrite ($objfile, " -l");
    fwrite ($objfile, "\n");
    }
  }
}

fwrite ($objfile, "\n
#\n
# Output Rules\n
#\n
");
if (is_array($rules)) {
  reset($rules);
  while ( list($key,$rule) = each($rules) ) {
    list ($type, $source, $dest, $proto, $port, $action, $log) = preg_split ("/[\s]+/", $rule);
    if ($type == "OUTPUT") {
    $log=chop($log);
    fwrite ($objfile, "\$IPCHAINS -A output");
    if ($proto != "ALL") fwrite ($objfile, " -p $proto");
    fwrite ($objfile, " -s $$source -d $$dest");
    if ($port != "ALL") fwrite ($objfile, " $port");
    fwrite ($objfile, " -j $action");
    if ($log == "YES") fwrite ($objfile, " -l");
    fwrite ($objfile, "\n");
    }
  }
}

fwrite ($objfile, "\n
#\n
# Forward Rules\n
#\n
");
if (is_array($rules)) {
  reset($rules);
  while ( list($key,$rule) = each($rules) ) {
    list ($type, $source, $dest, $proto, $port, $action, $log) = preg_split ("/[\s]+/", $rule);
    if ($type == "FORWARD") {
    $log=chop($log);
    fwrite ($objfile, "\$IPCHAINS -A forward");
    if ($proto != "ALL") fwrite ($objfile, " -p $proto");
    fwrite ($objfile, " -s $$source -d $$dest");
    if ($port != "ALL") fwrite ($objfile, " $port");
    fwrite ($objfile, " -j $action");
    if ($log == "YES") fwrite ($objfile, " -l");
    fwrite ($objfile, "\n");
    }
  }
}

fclose ($objfile);
print "<FONT COLOR=RED>DO NOT RELOAD THIS PAGE USING THE REFRESH BUTTON..</FONT><BR>";
print "Done.........<BR>";
print "Please click Reload Rules to make changes take effect..";
}

function update(){
print "Reloading chains.......";
passthru('/usr/bin/sudo /home/httpd/html/phpchains/fwscript');
}


?>
<script language="JavaScript">
<!-- hide from JavaScript-challenged browsers
 function openServices() {
     popupWin = window.open('services.php3', 'Services',
     'scrollbars,resizable,width=275,height=600')
      }
 function openInterfaces() {
      popupWin = window.open('interfaces.php3', 'Interfaces',
     'scrollbars,resizable,width=275,height=300')
      }
 function openProtocols() {
      popupWin = window.open('proto.php3', 'Protocols',
     'scrollbars,resizable,width=275,height=600')
      }
function openChainIn() {
      popupWin = window.open('rules.php3?INPUT', 'Protocols',
     'scrollbars,resizable,width=1000,height=600')
      }
function openChainOut() {
      popupWin = window.open('rules.php3?OUTPUT', 'Protocols',
     'scrollbars,resizable,width=1000,height=600')
      }
function openChainFwd() {
      popupWin = window.open('rules.php3?FORWARD', 'Protocols',
     'scrollbars,resizable,width=1000,height=600')
      }
function openObjects() {
      popupWin = window.open('objects.php3', 'Objects',
     'scrollbars,resizable,width=750,height=600')
      }
function WindowClose($win){
      window.close($win)
      }

// done hiding -->
</script>

</HEAD>

<BODY BGCOLOR="WHITE" TEXT="#9a9a9a" LINK="#EDEDED" VLINK=#EDEDED ALINK=#EDEDED>
<TABLE WIDTH=100% BGCOLOR=#486591>
<TR><TD ALIGN=LEFT VALIGN=TOP><FONT COLOR=WHITE><H2>IPChains Firewall Interface</H2></FONT></TD></TR>
</TABLE>
<TABLE WIDTH=100% BGCOLOR=#486591 BORDER=0>
<TR><TD ALIGN=CENTER>
<A HREF="javascript:openServices();" ALT="Services" onMouseOver="window.status='Services'; return true" onMouseOut="window.status='IPChains Firewall';">Services</A>
</TD><TD ALIGN=CENTER>
<A HREF="javascript:openProtocols();" ALT="Protocols" onMouseOver="window.status='Protocols'; return true" onMouseOut="window.status='IPChains Firewall';">Protocols</A>
</TD><TD ALIGN=CENTER>
<A HREF="javascript:openInterfaces();" onMouseOver="window.status='Interfaces'; return true" onMouseOut="window.status='IPChains Firewall';">Interfaces</A>
</TD><TD ALIGN=CENTER>
<A HREF="javascript:openObjects();" onMouseOver="window.status='Add-Edit Objects'; return true" onMouseOut="window.status='IPChains Firewall';">Network Objects</A>
</TD><TD ALIGN=CENTER>
<A HREF="javascript:openChainIn();" onMouseOver="window.status='Input Chains'; return true" onMouseOut="window.status='IPChains Firewall';">Input Chains</A>
</TD><TD ALIGN=CENTER>
<A HREF="javascript:openChainOut();" onMouseOver="window.status='Output Chains'; return true" onMouseOut="window.status='IPChains Firewall';">Output Chains</A>
</TD><TD ALIGN=CENTER>
<A HREF="javascript:openChainFwd();" onMouseOver="window.status='Forwarding Chains'; return true" onMouseOut="window.status='IPChains Firewall';">Forwarding Chains</A>
</TD>
</TR></TABLE>
<BR>
<BR>
<CENTER><FONT COLOR=RED SIZE=4><B>NOTICE!!: This script should only be run if you know what you are doing.<BR>
serious network problems could occur from a misconfiguration<BR> or misunderstanding of what an option does.</b></FONT></CENTER>

<?php
if (isset($cool)){
	switch($cool) {
	case "file":
		writefile();
	break;
	case "reload":
		update();
	break;
	}
}
print "<CENTER><FORM NAME=fm1 ACTION=\"index.php3\" METHOD=POST><INPUT TYPE=\"HIDDEN\" NAME=\"cool\" VALUE=\"file\"><INPUT TYPE=\"SUBMIT\" NAME=\"button\" VALUE=\"Re-Write Script\"></FORM>";
print "<CENTER><FORM NAME=fm2 ACTION=\"index.php3\" METHOD=POST><INPUT TYPE=\"HIDDEN\" NAME=\"cool\" VALUE=\"reload\"><INPUT TYPE=\"SUBMIT\" NAME=\"button\" VALUE=\"Reload Rules\"></FORM></CENTER></CENTER>";

#############################################################################
#
# Firewall script.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Current Script</B></TD>
<TD>
<HR>
<PRE>
<?
readfile ("fwscript");
print "<PRE><BR>";
?>
</PRE>

<HR></TD></TR>
</TABLE>
(c) Technology Unlimited, Inc. 2000 under the GPL
</BODY>
</HTML>

